/***************************************************************************
                          ksnes9x.h  -  description
                             -------------------
    begin                : Sun Oct 10 14:14:06 EST 1999
    copyright            : (C) 1999 by Perdig
    email                : perdig@linuxbr.com.br
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef KSNES9X_H
#define KSNES9X_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// include files for KDE
#include <kapp.h>
#include <ktmainwindow.h>
#include <kaccel.h>
#include <kiconloader.h>
#include <kmessagebox.h>
#include <kfiledialog.h>
#include <kprocess.h>
#include <kmenubar.h>
#include <kconfig.h>
#include <klocale.h>

// include files for QT
#include <qwidget.h>
#include <qapp.h>
#include <qstrlist.h>
#include <qstring.h>
#include <qrect.h>
#include <qpopupmenu.h>

// Application specific include files
#include "resource.h"
class KSnes9xView;
class KSnes9xConfig;
class KSnes9xOptionsDialog;
class inputInt;
class inputString;
class KSnes9xSnapshotDir;





class KSnes9x : public KTMainWindow {
  Q_OBJECT 
public: 
  /** construtor */
  KSnes9x(QWidget*parent=0,const char* name=0); 
  /** destructor */
  ~KSnes9x();
  /** enables menuentries/toolbar items  	*/
  void enableCommand(int id_);
  /** disables menuentries/toolbar items  	*/
  void disableCommand(int id_);
  /** Salva as opes */
  void saveOptions();
  /** Reseta a configuracao */
  void resetConfig();
  /** Chama a tela de configurao */
  void setup();
public slots:
  /** switch argument for slot selection by menu or toolbar ID */
  void commandCallback(int id_);
  /** Muda o diretorio */
  void slotStatusDir(const QString &);
  /** Roda o emulador */
  void goForIt();
protected:
	/** initKeyAccel creates the keyboard accelerator items for the available slots
	 and changes the menu accelerators. 		*/
	void initKeyAccel();
	/* Init the GUI */
  void initMenuBar();
	/** view item */
	KSnes9xView *view;
  /** Config object */
  KSnes9xConfig *cfg;
	/** Snapshot dir */
	KSnes9xSnapshotDir *snapDir;
  /**  */
  /**  */
  void saveRomOptions(const char *snapshot = NULL, const char *profile = NULL);
  QString currentRom;
	bool queryClose();
protected slots:
  /** Pede o nome do arquivo */
  void loadSnapshot(const QString& = NULL);
  /**  */
  void loadProfile(int id);
private:
	/** the configuration object of the application */
	KConfig *config;
  /** the key accelerator container */
	KAccel* key_accel;
  /** menuBar items */
  QPopupMenu *file_menu;
	QPopupMenu *graphics_menu;
	QPopupMenu *sound_menu;	
	QPopupMenu *cheat_menu;
	QPopupMenu *speed_menu;
	QPopupMenu *rom_menu;
	QPopupMenu *joystick_menu;
	QPopupMenu *help_menu;
	QPopupMenu *profile_menu;
  /** Processo a ser chamado */
  KShellProcess p;
  /** Profile em uso */
  int profile_index;
	/** Profile default */
	int default_profile;
	/** Lista de profiles */
	QStrList profiles;
private: // Private methods
  /** Inicializa os valores da MenuBar */
  void initMenuBarValues();
  /** Arruma os valores do cfg */
  void setCfgValues(int index);
  /** Bool option checked in the menubar */
  void slotBoolChecked(int _id);
  /** Chama a inputint */
  void slotIntChecked( int id );
  /** Inicializa a barra de status */
  void initStatusBar();
  /** Mostra uma messagem */
  void slotStatusMsg(const char *text);
  /** Temporary status bar text */
  void slotStatusHelpMsg(const char *text);
  /** Arruma os valores das opes gerais */
  /** Opo de cheat selecionada */
  /**  */

  void slotStrChecked(int id);
  void setCustomValues();
  /**  */
  void removeProfile();
  /**  */
  void newProfile();
  /** Inicializa o menu com todos os profiles */
  void initProfileMenu();
  /**  */
  void reloadPopupMenu();
  /**  */

  /**  */
  void initProfiles();
private slots: // Private slots
  /** Mostra o texto de status correspondente */
  void statusCallback(int id_);
protected slots: // Protected slots
  /** Atualiza o profile, snapshot do rom selecionado */
  void updateFileInfo(const QString &filename);
  /**  */
  void saveRomProfile(const QString&prof) { saveRomOptions(NULL, prof); };
};
#endif






































































































