/***************************************************************************
                          ksnes9xsnapshotdir.cpp  -  description
                             -------------------
    begin                : Tue Dec 21 1999
    copyright            : (C) 1999 by Perdig
    email                : perdig@linuxbr.com.br
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ksnes9xsnapshotdir.h"

KSnes9xSnapshotDir::KSnes9xSnapshotDir(QObject *parent, const char *name) : QObject( parent, name ) {
	dir = new KDirLister();
	connect( dir, SIGNAL(completed()), this, SLOT(loaded() ));
}

KSnes9xSnapshotDir::~KSnes9xSnapshotDir(){
}

/** Set the snapshot dir path */
void KSnes9xSnapshotDir::setPath(const char *path){
	dir->openURL( KURL::KURL(path) , false);
	snapPath = path;
}

/** Set the name of the rom */
void KSnes9xSnapshotDir::setRomName(QString name){
	name.replace( QRegExp("\\..*"), ".*" );
	dir->setNameFilter( name );
	dir->openURL( KURL::KURL(snapPath), false );
}

/** Ends loading the directory */
void KSnes9xSnapshotDir::loaded(){
	QStrList *nameList;
	fileList = dir->items();
	int index = 0;
	nameList = new QStrList();
	unsigned int a;
	for (a = 0; a < fileList.count(); a++) {
		if ( fileList.at(a) != NULL && !fileList.at(a)->isDir() && dir->matchesFilter( fileList.at(a)->url().path() )) {
			nameList->append( fileList.at(a)->url().path() );
		}
	}

	if (defSnap != NULL) {
		index = nameList->find( defSnap );
	// Add 1 to index because of the "none" option
		index++;
	}

	emit newMatch( nameList, index );
}

/**  */
void KSnes9xSnapshotDir::setFilter(QString filtro){
	filter = filtro;
}

/**  */
void KSnes9xSnapshotDir::setDefaultSnap( QString snap ){
	defSnap = snap;
}
