/***************************************************************************
                          ksnes9xview.cpp  -  description
                             -------------------
    begin                : Sun Oct 10 1999
    copyright            : (C) 1999 by Perdig
    email                : perdig@linuxbr.com.br
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "ksnes9xview.h"
#include <qlabel.h>

extern QString PATH;
extern QString FILTER;
extern bool QUICK_SNAP;
extern bool QUICK_PROF;

KSnes9xView::KSnes9xView(QWidget *parent, const char *name) : QWidget(parent,name){
	initKDir();
	initDialog();
}

KSnes9xView::~KSnes9xView(){
}



/** Inicializa o Kdir */
void KSnes9xView::initKDir(){
	dirView= new KDirOperator( KURL::KURL(PATH), this);
	if (FILTER.length() != 0)
		dirView->setNameFilter( (const QString &)FILTER );
	dirView->setOnlyDoubleClickSelectsFiles( true );
	dirView->setView(KFile::Default);

	connect(dirView, SIGNAL(fileHighlighted(const KFileViewItem *)), this, SLOT(choosenFile(const KFileViewItem *)));
	connect(dirView, SIGNAL(fileSelected(const KFileViewItem *)), this, SLOT(doubleClickedFile(const KFileViewItem *)));
	connect(dirView, SIGNAL(dirActivated(const KFileViewItem *)), this, SLOT(changeDir(const KFileViewItem *)));
}

bool KSnes9xView::ok() {
	const KFileViewItemList *list = dirView->selectedItems();
	KFileViewItemListIterator it (*list);
	return !it.current()->isDir();
}

QString KSnes9xView::fileName() {
	const KFileViewItemList *list = dirView->selectedItems();
	KFileViewItemListIterator it (*list);
	return it.current()->url().path();
}

void KSnes9xView::choosenFile(const KFileViewItem *file) {
	if (file == NULL)
		return;
	if (!file->isDir())
		emit fileClicked((const QString)file->url().path());
}

void KSnes9xView::doubleClickedFile(const KFileViewItem *file) {
	if (file == NULL)
		return;
	choosenFile( file );
	emit goPlay();
}

void KSnes9xView::changeDir(const KFileViewItem *dir) {
	if (dir == NULL)
		return;
	dirView->setURL(dir->url(), true);
	emit dirChanged(dir->url().path());
}

/**  */
void KSnes9xView::updateSnapMenu( QStrList *list, int index){
	unsigned int a;

	snapshot_list->clear();
	if (list->count() == 0)
	  snapshot_list->insertItem(i18n("None"));
	else
	  snapshot_list->insertItem(i18n("Select one"));
	for (a = 0; a < list->count(); a++) {
		snapshot_list->insertItem( list->at(a) );
	}	

	snapshot_list->setCurrentItem( index );
}

/**  */
void KSnes9xView::updateProfileMenu(QStrList profiles, unsigned int index){
	profile_list->clear();
	while (profiles.current() != NULL) {
		profile_list->insertItem(profiles.current());
		profiles.next();
	}
	profile_list->setCurrentItem( index );
}

/** Reload the layout, removing or inserting the Quick Snapshot/Profiles */
void KSnes9xView::rebuildLayout(){
	if (QUICK_PROF) {
		profile_list->show();
		QLabel_1->show();
	}		
	else {
		profile_list->hide();
		QLabel_1->hide();
	}

	if (QUICK_SNAP) {
		snapshot_list->show();	
		QLabel_3->show();
	}
	else {
		snapshot_list->hide();
		QLabel_3->hide();
	}
}















































